;====================================================
; FTP Function library Ver.1.00 29/10/02            ;
; Coded by Chevron                                  ;
; Feel Free to use and adapt                        ;
; No restrictions on use, just give me a credit     ;
;                                                   ;
; Credit goes to M.silby for the FTP_saveFile Func. ;
;====================================================
Global FTP$; Adress of the ftp server
Global FTP_login$; your login name
Global FTP_PASS$;your login password
Global FTP_ACCT$;you login account(not required for most ftp accounts)

Global FTP_msg$;returns command status and error messages from ftp server.
Global ftpcom;ftp command stream
Global FTP_data;ftp data stream
Global FTP_code;returns the last reply code from the ftp server.
Global transkbyte# ; returns the number of kbytes transfered in the last transfer.
Global transtime# ; returns the time taken to perform the last transfer.
Global transrate# ; returns the kbp's for the last data transfer.
Global FTP_help$; holds the remote help file, after help command execution.
Dim dp(6);used for 32bit ip address translations.

;-------------------------------------------------------------
Function FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)
;-------------------------------------------------------------
If ftpcom Then FTP_quit()
ftpcom=OpenTCPStream( FTP$,21 )

If Not ftpcom Notify "Connection failed. Please try again later.": Return False

Repeat

;upload connection FTP_data

FTP_getmsg()

Select FTP_code
Case 220
WriteLine ftpcom,"USER "+ftp_login$
Case 331
WriteLine ftpcom,"PASS "+ftp_pass$
;Case 332
;WriteLine ftpcom,"ACCT "+ftp_acct$
Case 530
RuntimeError "Log On Failed "+ftp_login$+" Cannot Log On" 
End Select
Until FTP_code=230


FTP_Mode("I");select binary transfer mode
Return True

End Function

;---------------------------
Function FTP_Changedir(dir$)
;---------------------------
If Not ftpcom Then FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$) 
WriteLine ftpcom,"CWD "+dir$
FTP_waitcode(250)
End Function

;----------------------------
Function FTP_Mode(code$)
;----------------------------
If Not ftpcom Then FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)
WriteLine ftpcom,"TYPE "+code
FTP_waitcode(200)
End Function

;---------------------------
Function FTP_servertype()
;---------------------------
If Not ftpcom Then FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)
WriteLine ftpcom,"SYST"
FTP_waitcode(200)
End Function

;---------------------------------
Function FTP_Put(Trans_file$,progress,x,y)
;---------------------------------
If Not ftpcom Then FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)
size#=1:time#=MilliSecs()

If FileSize(trans_file$)=0 
Return False 
EndIf

transfilesize#=FileSize(trans_file$)


open_data()

WriteLine ftpcom,"STOR "+trans_file$

file=ReadFile(trans_file$)
rd=file:wt=FTP_data
b=CreateBank(16384)

Repeat

n=ReadBytes( b,rd,0,16384)
WriteBytes b,wt,0,n
size#=size#+n
Until n<>16384

transkbyte#=size/1000
transtime#=(MilliSecs()-time#)/1000
transrate#=transkbyte#/transtime#

FreeBank b:CloseFile file:file=0:CloseTCPStream FTP_data:FTP_data=0

End Function

;-----------------------------
Function FTP_Get(Trans_file$,progressind,x,y)
;-----------------------------
If Not ftpcom Then FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)

If progressind=1
ftp_filesize(Trans_file$)
trans_fileSize#=Mid$(ftp_msg$,5)
EndIf

open_data()

WriteLine ftpcom,"RETR "+trans_file$

While ReadAvail(FTP_data)=0
Wend

FTP_Savefile(Trans_file$,1,x,y,trans_FileSize)

CloseTCPStream FTP_data:FTP_data=0

End Function

;--------------------------------------------------------
Function FTP_Savefile(filename$,cond,x,y,trans_filesize#)
;--------------------------------------------------------
time#=MilliSecs()
size#=0
file=WriteFile(filename$)
rd=FTP_data:wt=file

b=CreateBank(16384)

Repeat
n=ReadBytes( b,rd,0,16384 )
WriteBytes b,wt,0,n
size#=size#+n


If cond=1
transpercent=100-(((trans_filesize#-size#)/trans_filesize#)*100)
EndIf

Until n<>16384

transkbyte#=size/1000
transtime#=(MilliSecs()-time#)/1000
transrate#=transkbyte#/transtime#

FreeBank b
CloseFile file
file=0

If cond=1
transpercent=100
EndIf

End Function

;-----------------------------
Function open_data()
;-----------------------------
If Not ftpcom Then FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)
trys=0
.retry

WriteLine ftpcom,"PASV"

FTP_waitcode(227)

i1=Instr( FTP_msg$,"(" )
i2=Instr( FTP_msg$,")",i1 )
pt$=Mid$( FTP_msg$,i1+1,i2-i1-1 )+","

For k=1 To 6
i=Instr( pt$,"," )
dp(k)=Left$( pt$,i-1 )
pt$=Mid$(pt$,i+1)
Next

ip$=dp(1)+"."+dp(2)+"."+dp(3)+"."+dp(4)
port=(dp(5)Shl 8)Or dp(6)
FTP_data=OpenTCPStream(ip$,port)


If Not FTP_data

WriteLine ftpcom,"QUIT"
FTP_waitcode(221)
CloseTCPStream ftpcom:ftpcom=0

FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)
trys=trys+1
If trys=5 Then RuntimeError("Unable to connect to FTP server "+ftp$+" in passive mode") 
Goto retry
EndIf

End Function

;----------------------------
Function FTP_Getmsg()
;----------------------------

FTP_code=0
FTP_msg$=""
If ReadAvail(ftpcom)>0
Repeat
Repeat
FTP_msg$=ReadLine$(ftpcom)
Until Len(FTP_msg$)>3
FTP_code=Left$(FTP_msg$,3 )
Until FTP_code>=100 And FTP_code<600 And Mid$(FTP_msg$,4,1 )=" "
EndIf

End Function

;-------------------------------
Function FTP_waitcode(code)
;-------------------------------
FTP_code=0

While FTP_code<>code
FTP_getmsg()


If KeyHit(1)=True Return;allow user to escape if trapped
If FTP_code>400;error return
Return
EndIf

Wend
End Function

;----------------------------
Function FTP_Quit()
;----------------------------
WriteLine ftpcom,"QUIT"
;FTP_waitcode(221)
If ftpcom Then CloseTCPStream ftpcom:ftpcom=0
If FTP_data Then CloseTCPStream FTP_data:FTP_data=0

End Function

;---------------------------------
Function FTP_filesize(file$)
;---------------------------------
If Not ftpcom Then FTP_connect(ftp$,FTP_login$,FTP_pass$,FTP_acct$)
WriteLine ftpcom,"SIZE "+file$
FTP_waitcode(213)
End Function
